Define CONF_WORD = 0x3f62


'Program GCA133 Quadruple IR gate
'Activated IRGate will be accepted within 10 mSec (output goes low).
'switch off will take 0.5 - 2 seconds.(output goes high)

Symbol fn1 = RA4
Symbol fn2 = RB2
Symbol fn3 = RB6
Symbol fn4 = RB7
Symbol irs1 = RA0
Symbol irs2 = RA1
Symbol irs3 = RA2
Symbol irs4 = RA3
Symbol switch1 = RB0
Symbol switch2 = RB1
Symbol switch3 = RB4
Symbol switch4 = RB5
Dim ir_count(5) As Byte
AllDigital
CMCON = 7
TRISA = %001111
TRISB = %00110011
PORTA = 255
PORTB = 255
PWMon 1, 9  'set to 36 KHz output at RB3
PWMduty 1, 127
loop:

sensor_1:
	If irs1 = switch1 Then  'jumper dictates if input must be 1 or 0
		ir_count(1) = ir_count(1) + 1
		If ir_count(1) > 1 Then  'to switch on, a minimum of 20 mS is needed , before reaction is there
			fn1 = 0  'output on
			ir_count(1) = 200
		Endif
	Else
		If ir_count(1) > 0 Then
			ir_count(1) = ir_count(1) - 1
		Else
			fn1 = 1  'output off, if counted to zero
		Endif
	Endif

sensor_2:
	If irs2 = switch2 Then  'jumper dictates if input must be 1 or 0
		ir_count(2) = ir_count(2) + 1
		If ir_count(2) > 1 Then  'to switch on, a minimum of 20 mS is needed , before reaction is there
			fn2 = 0  'output on
			ir_count(2) = 200
		Endif
	Else
		If ir_count(2) > 0 Then
			ir_count(2) = ir_count(2) - 1
		Else
			fn2 = 1  'output off, if counted to zero
		Endif
	Endif

sensor_3:
	If irs3 = switch3 Then  'jumper dictates if input must be 1 or 0
		ir_count(3) = ir_count(3) + 1
		If ir_count(3) > 1 Then  'to switch on, a minimum of 20 mS is needed , before reaction is there
			fn3 = 0  'output on
			ir_count(3) = 200
		Endif
	Else
		If ir_count(3) > 0 Then
			ir_count(3) = ir_count(3) - 1
		Else
			fn3 = 1  'output off, if counted to zero
		Endif
	Endif

sensor_4:
	If irs4 = switch4 Then  'jumper dictates if input must be 1 or 0
		ir_count(4) = ir_count(4) + 1
		If ir_count(4) > 1 Then  'to switch on, a minimum of 20 mS is needed , before reaction is there
			fn4 = 0  'output on
			ir_count(4) = 200
		Endif
	Else
		If ir_count(4) > 0 Then
			ir_count(4) = ir_count(4) - 1
		Else
			fn4 = 1  'output off, if counted to zero
		Endif
	Endif

	WaitMs 10
Goto loop
End                                               